// Decompiled by:       Fernflower v0.6
// Date:                31.10.2010 19:09:03
// Copyright:           2008-2009, Stiver
// Home page:           http://www.reversed-java.com

package nl.codecup.game.dvonn;

import java.awt.Point;
import java.util.ArrayList;
import nl.codecup.game.dvonn.DvonnField;
import nl.codecup.game.dvonn.IllegalIDException;
import nl.codecup.game.dvonn.IllegalPositionException;

public class DvonnBoard {

   public static final int HEIGHT = 5;
   public static final int WIDTH = 11;
   public static final int A = 0;
   public static final int B = 1;
   public static final int C = 2;
   public static final int D = 3;
   public static final int E = 4;
   public static final int F = 5;
   public static final int G = 6;
   public static final int H = 7;
   public static final int I = 8;
   public static final int J = 9;
   public static final int K = 10;
   private DvonnField[][] grid = new DvonnField[5][11];


   public DvonnBoard() {
      for(int i = 0; i < 5; ++i) {
         for(int j = 0; j < 11; ++j) {
            this.grid[i][j] = new DvonnField();
         }
      }

      this.grid[3][0] = null;
      this.grid[4][0] = null;
      this.grid[4][1] = null;
      this.grid[0][9] = null;
      this.grid[0][10] = null;
      this.grid[1][10] = null;
   }

   public DvonnField[][] getGrid() {
      return this.grid;
   }

   public DvonnField getField(int y, int x) throws IllegalPositionException {
      if(x >= 0 && x < 11 && y >= 0 && y < 5 && this.grid[y][x] != null) {
         return this.grid[y][x];
      } else {
         throw new IllegalPositionException();
      }
   }

   public ArrayList getFieldsNotEmpty() {
      ArrayList fields = new ArrayList();

      for(int y = 0; y < 5; ++y) {
         for(int x = 0; x < 11; ++x) {
            if(this.grid[y][x] != null && !this.grid[y][x].isEmpty()) {
               fields.add(this.grid[y][x]);
            }
         }
      }

      return fields;
   }

   public ArrayList getFieldPointsNotEmpty() {
      ArrayList fields = new ArrayList();

      for(int y = 0; y < 5; ++y) {
         for(int x = 0; x < 11; ++x) {
            if(this.grid[y][x] != null && !this.grid[y][x].isEmpty()) {
               fields.add(new Point(x, y));
            }
         }
      }

      return fields;
   }

   public ArrayList getNeighborsNotEmpty(int y, int x, int r) throws IllegalPositionException {
      if(y >= 0 && y < 5 && x >= 0 && x < 11 && this.grid[y][x] != null) {
         ArrayList neighbors = new ArrayList();
         if(x - r >= 0 && this.grid[y][x - r] != null && !this.grid[y][x - r].isEmpty()) {
            neighbors.add(new Point(x - r, y));
         }

         if(x + r <= 10 && this.grid[y][x + r] != null && !this.grid[y][x + r].isEmpty()) {
            neighbors.add(new Point(x + r, y));
         }

         if(y - r >= 0 && this.grid[y - r][x] != null && !this.grid[y - r][x].isEmpty()) {
            neighbors.add(new Point(x, y - r));
         }

         if(y + r <= 4 && this.grid[y + r][x] != null && !this.grid[y + r][x].isEmpty()) {
            neighbors.add(new Point(x, y + r));
         }

         if(x - r >= 0 && y - r >= 0 && this.grid[y - r][x - r] != null && !this.grid[y - r][x - r].isEmpty()) {
            neighbors.add(new Point(x - r, y - r));
         }

         if(x + r <= 10 && y + r <= 4 && this.grid[y + r][x + r] != null && !this.grid[y + r][x + r].isEmpty()) {
            neighbors.add(new Point(x + r, y + r));
         }

         return neighbors;
      } else {
         throw new IllegalPositionException();
      }
   }

   public int getPosition(char c) {
      switch(c) {
      case 65:
         return 0;
      case 66:
         return 1;
      case 67:
         return 2;
      case 68:
         return 3;
      case 69:
         return 4;
      case 70:
         return 5;
      case 71:
         return 6;
      case 72:
         return 7;
      case 73:
         return 8;
      case 74:
         return 9;
      case 75:
         return 10;
      default:
         return 99;
      }
   }

   public void place(int y, int x, int color) throws IllegalIDException {
      this.grid[y][x].addStone(color);
   }

   public void move(int y1, int x1, int y2, int x2) {
      this.grid[y2][x2].addStack(this.grid[y1][x1].removeStones());
   }
}
